require "url_security/version"
require 'base64'
require 'openssl'

module UrlSecurity
  def self.included(base)
    base.extend self
  end

  def encrypt(param)
    c = cipher.encrypt
    c.key = Digest::SHA256.digest(add_key)
    Base64.encode64(c.update(param.to_s) + c.final)
  end

  def decrypt(param)
    c = cipher.decrypt
    c.key = Digest::SHA256.digest(add_key)
    c.update(Base64.decode64(param.to_s)) + c.final
  end

  def add_key
    'omus!'
  end

  def cipher
    OpenSSL::Cipher::Cipher.new('aes-256-cbc')
  end
end
